<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en">
<head>
	<title>CarbonPHP Documentation</title>
	<style type="text/css">
		* {
			margin: 0;
			padding: 0;
		}

		html {
			font-family: "Lucida Sans Unicode", "Lucida Grande";
			font-size: 14px;
		}

		body {
			background: #fff;
			color: #666;
		}

		h1 {
			font-size: 15px;
			font-weight: bold;
			margin-bottom: 5px;
		}

		ol, ul {
			margin: 10px 0 10px 0;
			list-style-position: inside;
		}

		p {
			margin: 5px 0 5px 0;
		}

		.content {
			border: 1px dotted #444;
			margin: 10px;
			padding: 10px;
			text-align: justify;
			width: 700px;
		}

		.example {
			border: 1px solid #ccc;
			background: #eee;
			margin: 10px;
			padding: 10px;
		}
	</style>
</head>

<body>
	<div class="content">
		<h1>Views</h1>

		<p>A view is another main part of model-view-controller frameworks.  A view is simply a web page, or page
		fragment, for example a header, footer, or sidebar.  Views must always be loaded by a controller.</p>

		<p>Using the example controller we previously created we will load a view to display the main page.</p>
	</div>

	<div class="content">
		<h1>Creating a View</h1>

		<p>Using your favorite text-editor, create a file called <b>blog_view.php</b>, and write the following.</p>

		<div class="example">
			&lt;html&gt;<br />
			&lt;head&gt;<br />
			&nbsp;&nbsp;&nbsp;&nbsp;&lt;title&gt;My Blog&lt;/title&gt;<br />
			&lt;/head&gt;<br />
			&lt;body&gt;<br />
			&nbsp;&nbsp;&nbsp;&nbsp;&lt;h1&gt;Welcome to My Blog&lt;/h1&gt;<br />
			&lt;/body&gt;<br />
			&lt;/html&gt;
		</div>

		<p>You can then save this file in the <b>application/views/</b> directory.</p>
	</div>

	<div class="content">
		<h1>Loading a View</h1>

		<p>To load a view you will call the following method.</p>

		<div class="example">
			$this->load->view('<b>name</b>');
		</div>

		<p>Where <b>name</b> is the name of the view file you created.  The file extension <b>.php</b> does not
		need to be specified unless you use something other than <b>.php</b>.  Now we can load the view file within
		the controller we created previously.</p>

		<div class="example">
			&lt;?php<br />
			<br />
			class Blog extends Controller<br />
			&#123;<br />
			&nbsp;&nbsp;&nbsp;&nbsp;public function index()<br />
			&nbsp;&nbsp;&nbsp;&nbsp;&#123;<br />
			&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;$this->load->view('blog_view');<br />
			&nbsp;&nbsp;&nbsp;&nbsp;&#125;<br />
			&#125;<br />
			<br />
			?&gt;
		</div>

		<p>Now if you visit the site using the URL like we did earlier you should now see the new view loaded.</p>

		<div class="example">
			www.your-domain.com/index.php/<b>blog</b>/
		</div>
	</div>

	<div class="content">
		<h1>Organising Views</h1>

		<p>View files can also be organised into subdirectories.  When you use this method you will have to include
		the name of the folder when loading the view.</p>

		<div class="example">
			$this->load->view('<b>directory_name</b>/<b>file_name</b>');
		</div>
	</div>

	<div class="content">
		<h1>Passing Dynamic Data to a View</h1>

		<p>Data can be passed from a controller to a view by passing an <b>array</b> or <b>object</b> in the
		second parameter of the view loading method.</p>

		<div class="example">
			$data = array(<br />
			&nbsp;&nbsp;&nbsp;&nbsp;'title' => 'Blog Title',<br />
			&nbsp;&nbsp;&nbsp;&nbsp;'heading' => 'Post Heading',<br />
			&nbsp;&nbsp;&nbsp;&nbsp;'message' => 'Post Message'<br />
			);<br />
			<br />
			$this->load->view('blog_view', $data);
		</div>

		<p>Below is an example of passing an object to a view.  <i>Note:</i> if you use an object, the class members
		will be turned into array elements.</p>

		<div class="example">
			$object = new ClassObject();<br />
			$this->load->view('blog_view', $object);
		</div>

		<p>Now we can modify the controller we created earlier to pass an array of data to our view.</p>

		<div class="example">
			&lt;?php<br />
			<br />
			class Blog extends Controller<br />
			&#123;<br />
			&nbsp;&nbsp;&nbsp;&nbsp;public function index()<br />
			&nbsp;&nbsp;&nbsp;&nbsp;&#123;<br />
			&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;$data['title'] = 'My Blog Title';<br />
			&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;$data['heading'] = 'My Blog Heading';<br />
			<br />
			&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;$this->load->view('blog_view', $data);<br />
			&nbsp;&nbsp;&nbsp;&nbsp;&#125;<br />
			&#125;<br />
			<br />
			?&gt;
		</div>

		<p>Once you have done this we can edit the <b>blog_view.php</b> file to include the variables we have
		created.</p>

		<div class="example">
			&lt;html&gt;<br />
			&lt;head&gt;<br />
			&nbsp;&nbsp;&nbsp;&nbsp;&lt;title&gt;&lt;?php echo $title; ?&gt;&lt;/title&gt;<br />
			&lt;/head&gt;<br />
			&lt;body&gt;<br />
			&nbsp;&nbsp;&nbsp;&nbsp;&lt;h1&gt;&lt;?php echo $heading; ?&gt;&lt;/h1&gt;<br />
			&lt;/body&gt;<br />
			&lt;/html&gt;
		</div>

		<p>Now if you load this page at the URL, you will see that the variables are replaced with the data that
		we passed to the view.</p>
	</div>

	<div class="content">
		<h1>Creating Loops in Views</h1>

		<p>Data passed to views is not limited to single variables.  You can pass multi-dimensional arrays, which
		can be looped to generate multiple rows.  When you retrieve data from your database it will typically be
		in the form of a multi-dimensional array.</p>

		<div class="example">
			&lt;?php<br />
			<br />
			class Blog extends Controller<br />
			&#123;<br />
			&nbsp;&nbsp;&nbsp;&nbsp;public function index()<br />
			&nbsp;&nbsp;&nbsp;&nbsp;&#123;<br />
			&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;$data['title'] = 'My Blog Title';<br />
			&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;$data['heading'] = 'My Blog Heading';<br />
			&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;$data['todo'] = array('Shop', 'Clean', 'Tidy up');<br />
			<br />
			&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;$this->load->view('blog_view', $data);<br />
			&nbsp;&nbsp;&nbsp;&nbsp;&#125;<br />
			&#125;<br />
			<br />
			?&gt;
		</div>

		<p>Now you can edit the file <b>blog_view.php</b> again to include a loop to iterate through the data
		passed to the view.</p>

		<div class="example">
			&lt;html&gt;<br />
			&lt;head&gt;<br />
			&nbsp;&nbsp;&nbsp;&nbsp;&lt;title&gt;&lt;?=$title;?&gt;&lt;/title&gt;<br />
			&lt;/head&gt;<br />
			&lt;body&gt;<br />
			&nbsp;&nbsp;&nbsp;&nbsp;&lt;h1&gt;&lt;?=$heading;?&gt;&lt;/h1&gt;<br />
			<br />
			&nbsp;&nbsp;&nbsp;&nbsp;&lt;h3&gt;Todo List&lt;/h3&gt;<br />
			<br />
			&nbsp;&nbsp;&nbsp;&nbsp;&lt;ul&gt;<br />
			&nbsp;&nbsp;&nbsp;&nbsp;&lt;?php foreach($todo as $item): ?s&gt;<br />
			&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&lt;li&gt;&lt;?=$item;?&gt;&lt;/li&gt;<br />
			&nbsp;&nbsp;&nbsp;&nbsp;&lt;?php endforeach; ?s&gt;<br />
			&lt;/body&gt;<br />
			&lt;/html&gt;
		</div>
	</div>
</body>

</html>
